<?php
// fb_exif Extension
// by Donald Tetto (with modifications by James Yencken)
// http://folderblog.org/
//
// Additional modifications made by Yovko Lambrev (http://yovko.net)

if(($page=="main"||$page=="comments") && (function_exists("exif_imagetype"))) {
    $data = exif_read_data($fbimage[1]);
    if(isset($data["ExposureTime"])) {
        list($num,$den) = explode("/",$data["ExposureTime"]);
        $den = $den/$num;   
        $fbexposure = "1/{$den}s";
    }
    if (isset($data["ISOSpeedRatings"])) {
        $fbiso = $data["ISOSpeedRatings"]; 
    }
    if (isset($data["MeteringMode"])) {
        switch($data["MeteringMode"]) {
            case 0:
                $fbmode = "Unknown";
                break;
            case 1:
                $fbmode = "Average";
                break;
            case 2:
                $fbmode = "CenterWeighted Average";
                break;
            case 3:
                $fbmode = "Spot";
                break;
            case 4:
                $fbmode = "Multi-Spot";
                break;
            case 5:
                $fbmode = "Multi-Pattern";
                break;
            case 6:
                $fbmode = "Partial";
                break;
            case 255:
                $fbmode = "Other";
                break;
            default:
                $fbmode = "";
                break;
        } 
    }
    if (isset($data["ExposureProgram"])) {
        switch($data["ExposureProgram"]) {
            case 0:
                $fbprogram = "Not Defined";
                break;
            case 1:
                $fbprogram = "Manual";
                break;
            case 2:
                $fbprogram = "Normal program";
                break;
            case 3:
                $fbprogram = "Aperture priority";
                break;
            case 4:
                $fbprogram = "Shutter priority";
                break;
            case 5:
                $fbprogram = "Creative program";
                break;
            case 6:
                $fbprogram = "Action program";
                break;
            case 7:
                $fbprogram = "Portrait mode";
                break;
            case 8:
                $fbprogram = "Landscape mode";
                break;
            default:
                $fbprogram = "";
                break;
        } 
    }
    if(isset($data["FNumber"])) {
        list($num,$den) = explode("/",$data["FNumber"]);
        $fbaperture  = "f/" . ($num/$den);
    }
    if(isset($data["FocalLength"])) {
        list($num,$den) = explode("/",$data["FocalLength"]);
        $fbfocallength  = ($num/$den) . "mm";
    }
    if(isset($data["FocalLengthIn35mmFilm"])) {
        $fbfocal35length  = $data["FocalLengthIn35mmFilm"] . "mm";
    }
    if(isset($data["ExposureBiasValue"])) {
        list($num,$den) = explode("/",$data["ExposureBiasValue"]);
        $fbexposurecomp = round(($num/$den),1);
        $fbexposurecomp = ($fbexposurecomp<0 ? "" : "+") . number_format($fbexposurecomp,1) . "ev";
    }
    if(isset($data["WhiteBalance"])) {
        switch($data["WhiteBalance"]) {
            case 0:
                $fbwhitebalance = "Auto";
                break;
            case 1:
                $fbwhitebalance = "Daylight";
                break;
            case 2:
                $fbwhitebalance = "Fluorescent";
                break;
            case 3:
                $fbwhitebalance = "Incandescent";
                break;
            case 4:
                $fbwhitebalance = "Flash";
                break;
            case 9:
                $fbwhitebalance = "Fine Weather";
                break;
            case 10:
                $fbwhitebalance = "Cloudy";
                break;
            case 11:
                $fbwhitebalance = "Shade";
                break;
            default:
                $fbwhitebalance = "";
                break;
        }
    }
}
$tags += array("<#fbcamera#>" => isset($data["Model"]) ? ucwords(strtolower($data["Model"])) : "",
               "<#fbflash#>" => isset($data["Flash"]) ? (bindec($data["Flash"]) ? "On" : "Off") : "",
               "<#fbfocallength#>" => isset($fbfocallength) ? $fbfocallength : "",
               "<#fbfocal35length#>" => isset($fbfocal35length) ? $fbfocal35length : "",
               "<#fbexposure#>" => isset($fbexposure) ? $fbexposure : "",
               "<#fbiso#>" => isset($fbiso) ? $fbiso : "",
               "<#fbmode#>" => isset($fbmode) ? $fbmode : "",
	       "<#fbprogram#>" => isset($fbprogram) ? $fbprogram : "",
               "<#fbaperture#>" => isset($fbaperture) ? $fbaperture : "",
               "<#fbwhitebalance#>" => isset($fbwhitebalance) ? $fbwhitebalance : "",
               "<#fbexposurecomp#>" => isset($fbexposurecomp) ? $fbexposurecomp : "",
               "<#fbtaken#>" => isset($data["DateTimeOriginal"]) ? str_replace(":","-",substr($data["DateTimeOriginal"],0,10)) . substr($data["DateTimeOriginal"],10) : "");
?>