<?php
/*
Extension Name: Folderblog MIME Type
Extension URI: http://elwing.byethost.com/journal/?page_id=19
Description: Extension that allows for MIME type negotiation, providing XHTML 1.1 served as application/xhtml+xml for browsers that can handle it, falling back to HTML 4.01 served as text/html for those that can not. Based on code written by Simon Jessey and Neil Crosby.
Author: Elwing
Version: 0.2
Author URI: http://elwing.bytehost.com/
*/

/* CUSTOMISE SETTINGS */
$charset = "utf-8"; // change this to suit as needed (default is UTF-8, see: http://www.w3.org/International/O-charset.html)
$doclang = "en-gb"; // set the language here (default is English, see: http://www.w3.org/WAI/ER/IG/ert/iso639.htm)
$quirksmode = ""; // set to "<!-- Internet Explorer runs in Quirksmode -->" to enable this feature

/* DO NOT EDIT BELOW */
$mime = "text/html";
function htmlize($buffer) {
	$buffer = str_replace("﻿","",$buffer);
	$buffer = str_replace("\n","",$buffer);
	$buffer = str_replace("\t","",$buffer);
	$buffer = str_replace(chr(13),"",$buffer);
	$buffer = ereg_replace("<!\-\- [\/\ a-zA-Z]* \-\->","",$buffer);
	$buffer = preg_replace("!\s*/>!",">",$buffer);
	return $buffer;
}
function strip($buffer){
	$buffer = str_replace("﻿","",$buffer);
	$buffer = str_replace("\n","",$buffer);
	$buffer = str_replace("\t","",$buffer);
	$buffer = str_replace(chr(13),"",$buffer);
	$buffer = ereg_replace("<!\-\- [\/\ a-zA-Z]* \-\->","",$buffer);
	return $buffer;
}
if (stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml")) {
	if (preg_match("/application\/xhtml\+xml;q=0(\.[1-9]+)/i",$_SERVER["HTTP_ACCEPT"],$matches)) {
		$xhtml_q = $matches[1];
		if (preg_match("/text\/html;q=0(\.[1-9]+)/i",$_SERVER["HTTP_ACCEPT"],$matches)) {
			$html_q = $matches[1];
			if ($xhtml_q >= $html_q) {
				$mime = "application/xhtml+xml";
			}
		}
	} else {
		$mime = "application/xhtml+xml";
	}
}
if (stristr($_SERVER["HTTP_USER_AGENT"],"W3C_Validator") || stristr($_SERVER["HTTP_USER_AGENT"],"W3C_CSS_Validator") || stristr($_SERVER["HTTP_USER_AGENT"],"WDG_Validator")) {
	$mime = "application/xhtml+xml";
}
if ($mime == "application/xhtml+xml") {
	ob_start("strip");
	$docstart = "<?xml version=\"1.0\" encoding=\"$charset\" ?>\n<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">\n<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"$doclang\">\n<head>\n<meta http-equiv=\"content-type\" content=\"$mime; charset=$charset\" />\n";
} else {
	ob_start("htmlize");
	$docstart = "$quirksmode<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">\n<html lang=\"$doclang\">\n<head>\n<meta http-equiv=\"content-type\" content=\"$mime; charset=$charset\" />\n";
}
header("Content-Type: $mime;charset=$charset");
header("Vary: Accept");
print $docstart;
?>